// Generated by CoffeeScript 1.6.3
var AutoCompleter, CucumberPlugin, Plugin, name, setup, util;

util = require("util");

Plugin = require("../cloud9.core/plugin");

AutoCompleter = require('./autocompleter');

name = "cucumber";

module.exports = setup = function(options, imports, register) {
    return imports.ide.register(name, CucumberPlugin, register);
};

CucumberPlugin = function(ide, workspace) {
    Plugin.call(this, ide, workspace);
    this.workspaceId = workspace.workspaceId;
    this.workspaceDir = ide.workspaceDir;
    this.completer = new AutoCompleter(this.workspaceDir);
    this.hooks = ["command"];
    return this.name = name;
};

util.inherits(CucumberPlugin, Plugin);

(function() {
    this.metadata = {
        "commands": {
            "autocomplete": {
                "hint": "autocomplete tag or step"
            }
        }
    };
    this.command = function(user, message, client) {
        if (!this["command-" + message.command]) {
            return false;
        }
        if ((message.runner != null) && message.runner !== "cucumber") {
            return false;
        }
        this["command-" + message.command.toLowerCase()](message);
        return true;
    };
    return this["command-cucumber-autocomplete"] = function(message) {
        var matches;
        matches = this.completer.getPhrases(message.line);
        console.log(matches);
        return this.sendResult(0, "cucumber-autocomplete", {
            matches: matches,
            line: message.line
        });
    };
}).call(CucumberPlugin.prototype);
